#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n, c, q;
    cin >> n >> c >> q;
    bool s[n];
    char ch;
    for(int i = 0; i < n; i++){
        cin >> ch;
        s[i] = ch - '0';
    }
    for(int i = 0; i < q; i++){
        int l, r, nule = 0, maks = 0;
        cin >> l >> r;
        for(int j = l - 1; j < r; j++){
            s[j] = !s[j];
        }
        for(int j = 0; j < n; j++){
            if(!s[j]){
                nule++;
            }
            else{
                int razlika = 0;
                for(int k = j; k < n; k++){
                    if(s[k]){
                        razlika++;
                        if(razlika > maks){
                            maks = razlika;
                        }
                    }
                    else{
                        razlika--;
                    }
                }
            }
        }
        if(c < maks){
            cout << c + n - nule - maks << endl;
        }
        else{
            cout << n - nule << endl;
        }

    }

}